//+------------------------------------------------------------------+
//|                                                 PolyFitCD_v1.mq4 |
//|                                Copyright  2009, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LightBlue
#property indicator_width1  2
#property indicator_color2  LightBlue
#property indicator_width2  1
#property indicator_style2  2
#property indicator_color3  Tomato
#property indicator_style3  2
//---- external variables
extern int Price           =   0;   //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close)
extern int Fast            =  14;   //Number of bars for an evaluation
extern int FastDegree      =   1;   //Degree of a Polynomial(no more 12)
extern int Slow            =  30;   //Number of bars for an evaluation
extern int SlowDegree      =   1;   //Degree of a Polynomial(no more 12)
extern int Signal          =   5;   //Period of Signal MA
extern int SignalMode      =   3;   //Mode of Signal MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA,4-SineWMA,5-TriMA
extern int PreSmooth       =   5;   //Period of Preliminary Smoothing
extern int PreSmoothMode   =   3;   //Mode of MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA
extern int ProjLength      =   3;   //Length of Projection
extern int BarsBack        =   0;   //Shift in history
extern int FitMode         =   1;   //Fitting Mode: 0-Fitting,1-Moving
extern int VisualMode      =   0;   //0-Line,1-Histogam 
extern int CountBars       = 500;   //Maximum Number of Bars(0-all Bars)
//---- indicator buffers
double PolyFitCD[];
double Project[];
double Sig[];
double ProjMax[];

//---- global variables
double PriceArray[];
int cBars, pTime;
//+---------------------------------------------------------------------------+
//| Custom indicator initialization function                                  |
//+---------------------------------------------------------------------------+
int init()
{
   if(BarsBack < 0) BarsBack = 0; 
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
      if(VisualMode == 0)
      {
      SetIndexStyle(0,DRAW_LINE);
      SetIndexStyle(1,DRAW_LINE);
      }
      else
      {
      SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
      SetIndexStyle(1,DRAW_HISTOGRAM);
      }   
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,158);

   SetIndexBuffer(0, PolyFitCD);
   SetIndexBuffer(1, Project);
   SetIndexBuffer(2, Sig);
   SetIndexBuffer(3, ProjMax);
   
   if(CountBars == 0) cBars = Bars - Slow - PreSmooth - Signal;
   else cBars = CountBars;
   
   SetIndexDrawBegin( 0,Bars-cBars-2); //cBars+(Slow+PreSmooth));
   SetIndexDrawBegin( 2,Bars-cBars-2);
   
   SetIndexShift(1,ProjLength - BarsBack);
      
   string short_name="PolyFitCD("+Price+","+Fast+","+FastDegree+","+Slow+","+SlowDegree+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"PolyFitCD");
   SetIndexLabel(1,"Projection");
   SetIndexLabel(2,"Signal");
   
   SetIndexEmptyValue(2,0.0);
   
   ArrayResize(PriceArray, Slow);
   
   return(0);
}
//----
double PolyFit(double price[],int deg,int len,int bar)
{
double   result=0,Sum=0;
double   AX[13,13],BX[13],CX[13],ZX[13],Pow[26];
int      Row[13];  

   if (len<=1)	Sum=price[0];
   else
   {	
   
   for (int j=1;j<=deg+1;j++) BX[j]=0;
		
		for (int k=1;k<=len;k++) 
  	   {
  	   double YK=price[len-k];
  	   double XK=k;
  	   double Prod=1;
  	      for (j=1;j<=deg+1;j++)
    	   {
    	   BX[j]+= YK*Prod;
    	   Prod*=XK;
  		   }
      }
      
   for (j=0;j<=2*deg;j++) Pow[j]=0;
	
	Pow[0]=len;
	
      for (k=1;k<=len;k++)
	   {
  	   XK=k;
  	   Prod=k;
  	      for (j=1;j<=2*deg;j++)
  	      {
    	   Pow[j]+= Prod;    	   
    	   Prod*= XK;
  		   }
      }	
	
	   for (j=1;j<=deg+1;j++)
	   {	
         for (int l=1;l<=deg+1;l++) 
  	      AX[j,l]=Pow[j+l-2];
      }	

	for (j=1;j<=deg+1;j++) Row[j]=j;
  	
      for (int i=1;i<=deg;i++)
  	   {
  	      for (k=i+1;k<=deg+1;k++)
         {
            if(MathAbs(AX[Row[k],i]) > MathAbs(AX[Row[i],i]))
      	   {	
      	   int Temp=Row[i];
      	   Row[i]=Row[k];
      	   Row[k]=Temp;
            }
         }

         for (k=i+1;k<=deg+1;k++)
    	   {
    	   if(AX[Row[i],i]!=0) AX[Row[k],i]=AX[Row[k],i]/AX[Row[i],i];
    		   for (l=i+1;l<=deg+1;l++)
      	   AX[Row[k],l]=AX[Row[k],l]-AX[Row[k],i]*AX[Row[i],l];
    		}
		}

   ZX[1]=BX[Row[1]];
      
      for (k=2;k<=deg+1;k++)
  	   {
  	   Sum=0;
      for (l=1;l<=k-1;l++) Sum+=AX[Row[k],l]*ZX[l];
  	   
  	   ZX[k]=BX[Row[k]]-Sum;
	   }
     
	if(AX[Row[deg+1],deg+1] != 0) CX[deg+1]=ZX[deg+1]/AX[Row[deg+1],deg+1];
      	
      for (k=deg;k>=1;k--)
  	   {
  	   Sum=0;
	    		
  	   for (l=k+1;l<=deg+1;l++) Sum += AX[Row[k],l]*CX[l]; 
  	   CX[k]=(ZX[k]-Sum)/AX[Row[k],k];
	   }
	Sum=CX[deg+1];
	for (k=deg;k>=1;k--) {Sum=CX[k]+Sum*(len+bar);}
   }
   return (Sum);
}	
//+------------------------------------------------------------------+
//| PolyFitCD_v1                                                   |
//+------------------------------------------------------------------+
int start()
{
   int i, j, shift, limit, counted_bars=IndicatorCounted();
   int len = Slow + Signal + PreSmooth;
      
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit = cBars-1+len; 
         
   if (FitMode==1 && counted_bars > 0) limit = Bars - counted_bars + BarsBack;
   else
   if (FitMode==0) {limit = BarsBack + Slow; len = cBars - Slow+1;} 
   
   if ( counted_bars < 1 || FitMode==0)
   { 
      for(i=1;i<len;i++)
      { 
      PolyFitCD[cBars-i]=EMPTY_VALUE;    
      Sig[cBars-i]=EMPTY_VALUE; 
      }
   }   
   
   if ( ProjLength > 0 )
   {  
      for(i=1;i<Slow;i++)
      Project[i]=EMPTY_VALUE;  
   } 
        
   for(shift = BarsBack;shift<=limit;shift++ )
   {
      if(shift < cBars + Signal + Slow + PreSmooth) 
      {
         for(j = 0; j < Slow; j++)
         PriceArray[j] = iMA(NULL,0,PreSmooth,0,PreSmoothMode,Price,shift*FitMode + j + (1-FitMode)*BarsBack);
            
      PolyFitCD[shift] = PolyFit(PriceArray,FastDegree,Fast,(shift-BarsBack)*(FitMode-1)) - PolyFit(PriceArray,SlowDegree,Slow,(shift-BarsBack)*(FitMode-1));
      
         if(ProjLength > 0 && shift == BarsBack)
         {
            for (j=ProjLength;j>=0;j--)
            Project[ProjLength-j] = PolyFit(PriceArray,FastDegree,Fast,j) - PolyFit(PriceArray,SlowDegree,Slow,j);
         }
      }         
   }
   
   for(shift = limit;shift>=BarsBack;shift--)
   {
      if(shift < cBars + Signal)
      {
         switch(SignalMode)
         {
         case 1 : Sig[shift] = EMA(PolyFitCD[shift],Sig,Signal,shift); break;
         case 2 : Sig[shift] = Wilder(PolyFitCD[shift],Sig,Signal,shift); break;  
         case 3 : Sig[shift] = LWMA(PolyFitCD,Signal,shift); break;
         case 4 : Sig[shift] = SineWMA(PolyFitCD,Signal,shift); break;
         case 5 : Sig[shift] = TriMA(PolyFitCD,Signal,shift); break;
         case 0 : Sig[shift] = SMA(PolyFitCD,Signal,shift); break;
         }
      }
   }   
   
   if(ProjLength > 0) ProjMax[0] = Project[0];
   
   
   return(0);
}
//+---------------------------------------------------------------------------+
// MA_Method=0: SMA - Simple Moving Average
double SMA(double array[],int per,int bar)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) Sum += array[bar+i];
   
   return(Sum/per);
}                
// MA_Method=1: EMA - Exponential Moving Average
double EMA(double price,double array[],int per,int bar)
{
   if(bar == cBars + per - 1) double ema = price;
   else 
   if(bar < cBars + per - 1) ema = array[bar+1] + 2.0/(1+per)*(price - array[bar+1]); 
   
   return(ema);
}               
// MA_Method=2: Wilder - Wilder Exponential Moving Average
double Wilder(double price,double array[],int per,int bar)
{
   if(bar == cBars + per - 1) double wilder = price; //SMA(array1,per,bar);
   else 
   if(bar < cBars + per - 1) wilder = array[bar+1] + (price - array[bar+1])/per; 
   
   return(wilder);
}
// MA_Method=3: LWMA - Linear Weighted Moving Average 
double LWMA(double array[],int per,int bar)
{
   double Sum = 0;
   double Weight = 0;
   
      for(int i = 0;i < per;i++)
      { 
      Weight+= (per - i);
      Sum += array[bar+i]*(per - i);
      }
   if(Weight>0) double lwma = Sum/Weight;
   else lwma = 0; 
   return(lwma);
} 
// MA_Method=4: SineWMA - Sine Weighted Moving Average
double SineWMA(double array[],int per,int bar)
{
   double pi = 3.1415926535;
   double Sum = 0;
   double Weight = 0;
  
      for(int i = 0;i < per-1;i++)
      { 
      Weight+= MathSin(pi*(i+1)/(per+1));
      Sum += array[bar+i]*MathSin(pi*(i+1)/(per+1)); 
      }
   if(Weight>0) double swma = Sum/Weight;
   else swma = 0; 
   return(swma);
}
// MA_Method=5: TriMA - Triangular Moving Average
double TriMA(double array[],int per,int bar)
{
   double sma;
   int len = MathCeil((per+1)*0.5);
   
   double sum=0;
   for(int i = 0;i < len;i++) 
   {
   sma = SMA(array,len,bar+i);
   sum += sma;
   } 
   double trima = sum/len;
   
   return(trima);
}


